{$N-,E- no math support needed}
{$X- function calls may not be discarded}
{$I- disable I/O checking (trap errors by checking IOResult)}

PROCEDURE ExitOnError (err : BYTE; msg : STRING);
CONST
  NL = #13#10;
BEGIN
  WriteLn ('RenFile v1.00 - Free DOS utility: Rename almost any DOS (FAT system) file.');
  WriteLn ('September 17, 1996. Copyright (c) 1996 by David Daniel Anderson - Reign Ware.'+NL);
  WriteLn ('Usage:    RenFile  "Old name"  "New name"'+NL);
  WriteLn ('Example:  RenFile  "letter"  "pri vate"'+NL);
  IF err > 0 THEN BEGIN
    WriteLn ('Error encountered (#', err, '):');
    WriteLn (msg);
  END;
  Halt (err);
END;

FUNCTION RTrim (InStr: STRING): STRING;
BEGIN
  WHILE (Length (InStr) > 0) AND (InStr [Length (InStr)] IN [#0, #9, #32]) DO
    Dec (InStr [0]);
  RTrim := InStr;
END;

FUNCTION LTrim (InStr: STRING): STRING;
BEGIN
  WHILE (Length (InStr) > 0) AND (InStr [1] IN [#0, #9, #32]) DO
    Delete (InStr, 1, 1);
  LTrim := InStr;
END;

FUNCTION Trim (InStr: STRING): STRING;
BEGIN
  Trim := RTrim (LTrim (InStr));
END;

VAR
  CmdLine,
  oldName, newName : STRING;
  sepChar : CHAR;
  FileToRen : FILE;
  Index : BYTE;

BEGIN
  oldName := '';
  newName := '';

  CmdLine := Trim (STRING (Ptr (PrefixSeg, $0080)^));
  IF CmdLine [1] <> CmdLine[Length(CmdLine)] THEN
    ExitOnError (2, 'You did not delimit the "Old name" and "New name" identically.');
  sepChar := CmdLine [1];

  CmdLine := Copy (CmdLine, 2, Length (CmdLine) - 1);
  Index := Pos (sepChar, CmdLine);
  oldName := Copy (CmdLine, 1, Index - 1);

  CmdLine := Copy (CmdLine, Index + 1, Length (CmdLine) - Index);
  Index := Pos (sepChar, CmdLine);
  newName := Copy (CmdLine, Index + 1, Length (CmdLine) - Index - 1);

  IF (oldName = '') OR (newName = '') THEN
    ExitOnError (1, 'You must specify both a new name and an old name.');

  Write ('Renaming "', oldName, '" to "', newName, '"');

  Assign (FileToRen, oldName);
  Rename (FileToRen, newName);

  IF IOResult <> 0 THEN
  BEGIN
    WriteLn (' FAILED!', #7);
    WriteLn;
    ExitOnError (7, 'You may have attempted to use illegal characters.');
  END
  ELSE
    WriteLn (' succeeded!');
END.
